unit Thmbcode;

interface

uses
  SysUtils, WinTypes, WinProcs, Controls, Forms, StrRes,
	Balloon, Classes, StdCtrls;

var
	THMBType, MessageContent, MessageCaption, RegType,
		MessageMacros, FunctionName, MsgMacros,
		MBMacro1,MBMacro2, MacroID, WriteID, Opt321,opt322: String;
	MBITEFlag, MBMacFlag, THMBVal, THMBFlag1, THMBFlag2: Integer;
	Expertmode: Boolean;


type
  TTHMB = class(TForm)
	Preview: TEdit;
    Label1: TLabel;
    GroupBox1: TGroupBox;
	GroupBox4: TGroupBox;
	Button2: TButton;
	Button3: TButton;
    Button6: TButton;
	IconType: TComboBox;
	MBXType: TComboBox;
	Label2: TLabel;
	Labeel3: TLabel;
	Option1: TRadioButton;
	Option2: TRadioButton;
	Option3: TRadioButton;
	MBMacroString1: TEdit;
	MBMacroString2: TEdit;
	MsgCaption: TEdit;
	MsgContent: TEdit;
	MacroLabel1: TLabel;
	MacroLabel2: TLabel;
	Label6: TLabel;
	Label7: TLabel;
	StrRes1: TStrRes;
	CheckBox1: TCheckBox;
	CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
	Button1: TButton;
	Edit1: TEdit;
	procedure IconTypeChange(Sender: TObject);
	procedure Button6Click(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure MBMacroString1Change(Sender: TObject);
	procedure MBMacroString2Change(Sender: TObject);
	procedure MsgCaptionChange(Sender: TObject);
	procedure MsgContentChange(Sender: TObject);
	procedure Button1Click(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure Button4Click(Sender: TObject);
	procedure Button3Click(Sender: TObject);
	procedure MBXTypeChange(Sender: TObject);
	procedure Option2Click(Sender: TObject);
	procedure Option3Click(Sender: TObject);
	procedure Option1Click(Sender: TObject);
	procedure CheckBox1Click(Sender: TObject);
	procedure CheckBox3Click(Sender: TObject);
  private
	{ Private declarations }
procedure Update_THMB;
procedure THMBPreview;
  public
	{ Public declarations }
  end;

var
  THMB: TTHMB;

implementation

{$R *.DFM}

uses sampmenu;

procedure TTHMB.IconTypeChange(Sender: TObject);
begin
	THMBFlag1 := IconType.ItemIndex * 16;
	Update_THMB
end;

procedure TTHMB.THMBPreview;
begin
	Preview.Text := THMBType + MessageContent + Chr(39) +',`' +
		MessageCaption + #39 + ',' + IntToStr(THMBVal) + ')' + MessageMacros;
end;

procedure TTHMB.Button6Click(Sender: TObject);
var p1,p2: array [0..255] of char;
begin
	StrPCopy(p1,MessageContent);
	StrPCopy(p2,MessageCaption);
	MessageBox(Self.Handle,P1,P2,THMBVal);
end;

procedure TTHMB.Update_THMB;
begin
	If MBXType.ItemIndex = 0 Then begin
		Option1.Checked := True;
		Option2.Enabled := False;
		Option3.Enabled := False;
		end
	Else begin
		Option2.Enabled := True;
		Option3.Enabled := True;
		end;

	If MBMacFlag = 0 Then THMBType := FunctionName + '(0,`';
	If MBMacFlag = 1 Then THMBType := 'IfThen(' + FunctionName + '(0,`';
	If MBMacFlag = 2 Then THMBType := 'IfThenElse(' + FunctionName + '(0,`';
	If MBMacFlag = 0 Then MsgMacros := '';
	If MBMacFlag = 1 Then MsgMacros := ' , ' + Opt321 + MBMacro1 + Opt322 + ')';
	If MBMacFlag = 2 Then MsgMacros := ' , ' + Opt321 + MBMacro1 + Opt322 + ', ' + Opt321 + MBMacro2 + Opt322 +')';
	THMBVal := THMBFlag1 + THMBFlag2;
	Preview.Text := THMBType+MessageContent + #39 +',`'+MessageCaption+ #39 +',' + IntToStr(THMBVal) + ')' + MsgMacros;
	MacroID := Preview.Text;
	WriteID := MacroID;
end;


procedure TTHMB.FormCreate(Sender: TObject);
begin
	Font.Name := 'MS Sans Serif';
{Set hinting}
	GetPrivateProfileString(Section,'Hints','',Retstring,SizeOf(RetString),INIFile);
	If StrPas(RetString) = StrPas('Off') Then begin
		Application.ShowHint := False;
		CheckBox3.Checked := False;
	end else begin
		Application.ShowHint := True;
		CheckBox3.Checked := True;
	End;

{    CallingForm = 'THMB';}
	Opt321 := '`';
	Opt322 := #39;
	RegType := 'u=USSU';
	ExpertMode := False;
	FunctionName := 'WHMessageBox';
	MBXType.Items.Add('Simple OK message');
	MBXType.Items.Add('OK and Cancel buttons');
	MBXType.Items.Add('Abort/Retry/Ignore buttons');
	MBXType.Items.Add('Yes, No and Cancel buttons');
	MBXType.Items.Add('Yes and No buttons');
	MBXType.Items.Add('Retry and Cancel buttons');
	MBXType.ItemIndex := 0;
	IconType.Items.Add('(no icon)');
	IconType.Items.Add('Stop icon');
	IconType.Items.Add('Question mark icon (?)');
	IconType.Items.Add('Exclamation mark icon (!)');
	IconType.Items.Add('Information icon (i)');
	IconType.ItemIndex := 0;
	THMBType := FunctionName + '(hwndContext,`';
	THMBVal := 0;
	MBMacFlag := 0;
	Update_THMB;
{	THMBPreview.Text := THMBType + StrRes1[0];}

end;

procedure TTHMB.MBMacroString1Change(Sender: TObject);
begin
	MBMacro1 := MBMacroString1.Text;
	Update_THMB;
end;

procedure TTHMB.MBMacroString2Change(Sender: TObject);
begin
	MBMacro2 := MBMacroString2.Text;
	Update_THMB;
end;

procedure TTHMB.MsgCaptionChange(Sender: TObject);
var Err: boolean;
	P1, P2: array [0..255] of Char;
begin
err := False;
StrPCopy(P1,StrRes1[4]);
StrPCopy(P2,MsgCaption.Text);
If StrScan(P2,Chr(34)) <> nil then Err := True;
If StrScan(P2,Chr(39)) <> nil then Err := True;
If StrScan(P2,Chr(40)) <> nil then Err := True;
If StrScan(P2,Chr(41)) <> nil then Err := True;
If StrScan(P2,Chr(123)) <> nil then Err := True;
If StrScan(P2,Chr(125)) <> nil then Err := True;
If StrScan(P2,Chr(92)) <> nil then Err := True;

If Err = True then
	MessageBox(Self.Handle,P1,'Illegal character detected',48);


{Edit2.text := IntToStr(Pos(MsgCaption.Text,Chr(34)));}
	MessageCaption := MsgCaption.Text;
	Update_THMB;
end;

procedure TTHMB.MsgContentChange(Sender: TObject);
var Err: boolean;
	P1, P2: array [0..255] of Char;
begin
err := False;
StrPCopy(P1,StrRes1[4]);
StrPCopy(P2,MsgContent.Text);
If StrScan(P2,Chr(34)) <> nil then Err := True;
If StrScan(P2,Chr(39)) <> nil then Err := True;
If StrScan(P2,Chr(40)) <> nil then Err := True;
If StrScan(P2,Chr(41)) <> nil then Err := True;
If StrScan(P2,Chr(123)) <> nil then Err := True;
If StrScan(P2,Chr(125)) <> nil then Err := True;
If StrScan(P2,Chr(92)) <> nil then Err := True;

If Err = True then
	MessageBox(Self.Handle,P1,'Illegal character detected',48);

	MessageContent := MsgContent.Text;
	Update_THMB;
end;

procedure TTHMB.Button1Click(Sender: TObject);
var s1,s2: string;
	p1: array[0..999] of Char;
begin
	If FunctionName = 'WHMB' then
		S1 := 'RR(' else
		S1 := 'RegisterRoutine(';
	If Checkbox2.Checked = True Then
		s2 := '`si32help.dll' + #39 + ',`'
		else s2 := '`si16help.dll' + #39 + ',`';

	Edit1.Text := S1 + S2 + FunctionName + #39 + ',`u=USSu' + #39 + ')';
	Edit1.SelectAll;
	Edit1.CopyToClipboard;
	StrPCopy(p1,StrRes1[3] + StrRes1[4]);
	MessageBox(Self.Handle,p1,'RegisterRoutine() macro copied...',64);
end;

procedure TTHMB.Button2Click(Sender: TObject);
begin
	Close;
end;

procedure TTHMB.Button4Click(Sender: TObject);
begin
{
		WriteRR;
}
end;

procedure TTHMB.Button3Click(Sender: TObject);
var i1: integer;
	p1: array [0..255] of char;
begin
	i1 := 0;
	StrPCopy(p1,StrRes1[1]);
	If MsgCaption.Text = '' Then
		MessageBox(Self.Handle,p1,'Macro parameter error detected',52);
	If i1 = 7 Then Exit;
	If MBMacFlag = 0 Then THMBType := FunctionName + '(hwndContext,`';
	If MBMacFlag = 1 Then THMBType := 'IfThen(' + FunctionName + '(hwndContext,`';
	If MBMacFlag = 2 Then THMBType := 'IfThenElse(' + FunctionName + '(hwndContext,`';
	If MBMacFlag = 0 Then MsgMacros := '';
	If MBMacFlag = 1 Then MsgMacros := ' ,`' + MBMacro1 + #39 + ')';
	If MBMacFlag = 2 Then MsgMacros := ' ,`' + MBMacro1 + #39 + ',`' + MBMacro2 + #39 + ')';
	THMBVal := THMBFlag1 + THMBFlag2;
	Preview.Text := THMBType + MessageContent + #39 + ',`' + MessageCaption + #39 +',' + IntToStr(THMBVal) + ')' + MsgMacros;
	Preview.SelectAll;
	Preview.CopyToClipboard;
	StrPCopy(p1,'The' + FunctionName + StrRes1[2]);
	MessageBox(Self.Handle, p1,'Macro copied to clipboard',64);
end;

procedure TTHMB.MBXTypeChange(Sender: TObject);
begin
	THMBFlag2 := MBXType.ItemIndex;
	Update_THMB;
end;

procedure TTHMB.Option2Click(Sender: TObject);
begin
	MBMacFlag := 1;
	MacroLabel1.Enabled := True;
	MacroLabel2.Enabled :=False;
	MBMacroString1.Enabled := True;
	MBMacroString2.Enabled := False;
	Update_THMB;
end;

procedure TTHMB.Option3Click(Sender: TObject);
begin
	MBMacFlag := 2;
	MacroLabel1.Enabled := True;
	MacroLabel2.Enabled :=True;
	MBMacroString1.Enabled := True;
	MBMacroString2.Enabled := True;
	Update_THMB;
end;

procedure TTHMB.Option1Click(Sender: TObject);
begin
	MBMacFlag := 0;
	MacroLabel1.Enabled := False;
	MacroLabel2.Enabled :=False;
	MBMacroString1.Enabled := False;
	MBMacroString2.Enabled := False;
	Update_THMB;
end;

procedure TTHMB.CheckBox1Click(Sender: TObject);
begin
	If Checkbox1.Checked = True Then
		FunctionName := 'WHMB' Else
		FunctionName := 'WHMessageBox';
	Update_THMB;
end;

procedure TTHMB.CheckBox3Click(Sender: TObject);
begin
	If Checkbox3.Checked = True Then begin
		Application.ShowHint := True;
		WritePrivateProfileString(Section,'Hints','On',INIFile);
	end else begin
		WritePrivateProfileString(Section,'Hints','Off',INIFile);
		Application.ShowHint := False;
	end;
end;

end.
